=== debian/changelog ===
zxing-cpp (1.2.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Tue, 17 Aug 2021 20:52:32 -0400

zxing-cpp (1.2.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/control: Add new build-dependency: qtbase5-dev.

 -- Boyuan Yang <byang@debian.org>  Wed, 16 Jun 2021 16:24:25 -0400
